unit DD77simpleU1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TDD77simpleF1 = class(TForm)
    laQuestion: TLabel;
    eUsersAnswer: TEdit;
    laMessages: TLabel;
    laUser: TLabel;
    laQsDone: TLabel;
    laScore: TLabel;
    buQuit: TButton;
    procedure buQuitClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure eUsersAnswerKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
    iScore:integer;//User's score
    bTmp, bQsDone:byte;//How many questions have been answered
    sUserName,sRightAnswer:string;
    procedure GetID;
    procedure PrepQ;
  public
    { Public declarations }
  end;

const ver='5 Apr 09';
//started 2 Apr 09

var
  DD77simpleF1: TDD77simpleF1;

implementation

{$R *.DFM}

procedure TDD77simpleF1.buQuitClick(Sender: TObject);
begin
application.terminate;
end;

procedure TDD77simpleF1.GetID;
begin
sUserName:=InputBox('GetID', 'User name?', '');
laUser.caption:=sUserName;
end;

procedure TDD77simpleF1.PrepQ;
//Very crude!!!
begin
//Next pick the question, and put on screen...
//This is a very crude question picking algorithm, of
//   course, and the same question can be presented
//   twice in a row. But there is nothing in the design
//   of the program to prevent us from making the
//   question picking better. In fact, this tutorial
//   arises from a program I was working on in which
//   the computer keeps track of the user's success
//   on each individual question, and presents the user
//   with just the questions he/she needs to work on
//   See http://tinyurl.com/SheepdogOffers
//   (http://www.arunet.co.uk/tkboyd/offers.htm)
//   for software with such refinements.

bTmp:=random(5); //Will only return 0-4, inclusive
//Yes, and array and a Case statement would have done
//      the following better.
if bTmp=0 then begin
  laQuestion.caption:='What is the capital of England?';
  sRightAnswer:='London';
  end;
if bTmp=1 then begin
  laQuestion.caption:='What is the capital of Spain?';
  sRightAnswer:='Madrid';
  end;
if bTmp=2 then begin
  laQuestion.caption:='What is the capital of Germany?';
  sRightAnswer:='Berlin';
  end;
if bTmp=3 then begin
  laQuestion.caption:='What is the capital of the USA?';
  sRightAnswer:='Washington';
  end;
if bTmp=4 then begin
  laQuestion.caption:='What is the capital of Peru?';
  sRightAnswer:='Lima';
  end;

//Empty the edit box
eUsersAnswer.text:='';
//Enable it.
eUsersAnswer.enabled:=true;
end; //of FormCreate

procedure TDD77simpleF1.FormCreate(Sender: TObject);
begin
randomize;
iScore:=0;//Start the user's score at zero.
bQsDone:=0;//Start the tally of how many questions answered at zero.
eUsersAnswer.enabled:=false;
eUsersAnswer.text:='';
GetID;
PrepQ;
end;

procedure TDD77simpleF1.eUsersAnswerKeyPress(Sender: TObject;
  var Key: Char);
begin
if key=chr(13) then {has no else clause} begin //1a
   if eUsersAnswer.text=sRightAnswer then begin //2a
   laMessages.caption:='Right! Good!';
   iScore:=iScore+20;
   inc(bQsDone);
   end//no ; here    2a
  else begin //2b
   laMessages.caption:='No. Answer was: '+sRightAnswer;
   inc(bQsDone);
   end;// 2b

if bQsDone<5 then PrepQ //no; here  (<5 because the count of q's
     //done goes up AFTER this point in the code.
  else buQuitClick(self);

laQsDone.caption:=inttostr(bQsDone);
laScore.caption:=inttostr(iScore);

PrepQ;

end;//1b
end;

end.
